from django.db import models

# Create your models here.
class AssetType(models.Model):
	name      = models.CharField(max_length=80)
	def __unicode__(obj):
		return obj.name 

class TradingPair(models.Model):
	Primary   = models.ForeignKey(AssetType, related_name='pair_primary')
	Secondary = models.ForeignKey(AssetType, related_name='pair_secondary') 
	""" @todo: Uniqueness is very specific here """

	def __unicode__(obj):
		return obj.Primary.__unicode__() + "/" + obj.Secondary.__unicode__()

class Account(models.Model):
	pass

class IOTransaction(models.Model):
	asset = models.ForeignKey(AssetType)
	volume = models.IntegerField() 
	account = models.ForeignKey(Account)

class Order(models.Model):	
	TYPECHOICE = (
		('S', 'Sell'),
		('B', 'Buy'),
		)

	STATUSCHOICE = (
		('A', 'Outstanding'),
		('C', 'Cancelled'),
		('S', 'Split'),
	)

	ordertype = models.CharField(max_length=1, choices=TYPECHOICE)
	# statustype= models.CharField(max_length=1, choices=STATUSCHOICE) 

	pair      = models.ForeignKey(TradingPair)

	quantity  = models.IntegerField() # Quantity PRIMARY
	account   = models.ForeignKey(Account)
	price     = models.IntegerField() # Price in SECONDARY for UNIT of PRIMARY. 

	reference = models.ForeignKey('Order', null=True, blank=True)  

	submitted = models.DateTimeField(auto_now_add = True)
	executed  = models.DateTimeField(null=True, blank=True)  
